#define INCL_GPI
#include <os2.h>
#include <string.h>

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT PaintIt1(HWND);
MRESULT PaintIt2(HWND);
MRESULT PaintIt3(HWND);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Basic Framework";
   char  szWindowTitle[] = "Basic Framework Window Title";
   ULONG flFrameOpts = FCF_STANDARD & ~FCF_ICON &  
                       ~FCF_MENU & ~FCF_ACCELTABLE;


   hab = WinInitialize(0);          
   hmq = WinCreateMsgQueue(hab, 0); 
   WinRegisterClass(hab, szClassName, ClientWndProc, 
                    CS_SIZEREDRAW, 0);

   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                 &flFrameOpts, szClassName,
                                 szWindowTitle, 0L, 0, 0, 
                                 &hwndClient);

   while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);
 
   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   /*event handler*/
   switch(msg) { 
      case WM_PAINT:
      PaintIt3(hwnd);
      return 0;
      }
   /*end event handlers */

   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }

MRESULT PaintIt1(HWND hwnd)
{
   HPS   hps;
   RECTL rcl;

   hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
   WinQueryWindowRect(hwnd, &rcl);
   WinFillRect(hps, &rcl, CLR_WHITE);
   WinEndPaint(hps);
   return 0;
   }          

MRESULT PaintIt2(HWND hwnd)
{
   HPS   hps;
   RECTL rcl;
   char  text[] = "Hello, World!";

   hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
   WinQueryWindowRect(hwnd, &rcl);
   WinFillRect(hps, &rcl, CLR_BACKGROUND);
   GpiSetBackMix(hps, BM_OVERPAINT);
   WinDrawText(hps, -1, text, &rcl, CLR_RED, CLR_GREEN, /* DT_TEXTATTRS |*/ DT_CENTER  | DT_VCENTER);
   WinEndPaint(hps);
   return 0;
   }

MRESULT PaintIt3(HWND hwnd)
{
   HPS   hps;
   RECTL rcl;
   char  text[] = "Hello, World.  Welcome to PresentationManager programming.  In the WorkPlace Shell, large windows full of text are fairly rare.";
   LONG  len, written, charHeight;
   FONTMETRICS  fontMetrics;

   hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
   WinQueryWindowRect(hwnd, &rcl);
   WinFillRect(hps, &rcl, CLR_WHITE);
   GpiQueryFontMetrics(hps, sizeof(fontMetrics), &fontMetrics);
   charHeight = fontMetrics.lMaxBaselineExt;
   rcl.yBottom = rcl.yTop-charHeight;
   len = strlen(text);
   written = 0;
   while (written < len) {
      written = written + WinDrawText(hps, -1, text+written, &rcl, 0, 0, DT_TEXTATTRS | DT_WORDBREAK);
      rcl.yTop = rcl.yTop - charHeight;
      rcl.yBottom = rcl.yBottom - charHeight;
      if (rcl.yBottom < 0) break;
      } /* endwhile */
   WinEndPaint(hps);
   return 0;
   }
