#define INCL_GPI
#define INCL_WIN
#include <os2.h>

#include "spin.h"

/* ClientWndProc is a dialog procedure */
MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);

int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndDlg;                /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Spin Buttons";
   BOOL  fail = FALSE;

   PSZ   months[] = {"January", "February", "March", 
           "April", "May", "June", "July", "August",
     "September", "October", "November", "December"};
   HWND  spin;

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 0))
                    fail = TRUE;

   hwndDlg   = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
                ClientWndProc, 0, SPINPROGRAMID, NULL);

   WinSendDlgItemMsg(hwndDlg, SP_DAY, SPBM_OVERRIDESETLIMITS,
                        MPFROMLONG(31), MPFROMLONG(1));
   WinSendDlgItemMsg(hwndDlg, SP_MONTH, SPBM_SETARRAY,
                        MPFROMLONG(months), MPFROMLONG(12));
   WinSendDlgItemMsg(hwndDlg, SP_YEAR, SPBM_SETLIMITS,
                        MPFROMLONG(1995), MPFROMLONG(1974));

   spin = WinWindowFromID(hwndDlg, SP_YEAR);
   WinSendDlgItemMsg(hwndDlg, SP_DAY, SPBM_SETMASTER,
                        MPFROMP(spin), 0);
   WinSendDlgItemMsg(hwndDlg, SP_MONTH, SPBM_SETMASTER,
                        MPFROMP(spin), 0);
 
   if ((fail) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndDlg==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else
      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);


   WinDestroyWindow(hwndDlg);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   long dim[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
   long day, year, selmo;
   char month[10];
   char message[1000];

   /*event handler*/
   switch(msg) {
 
      case WM_CONTROL:
      switch(SHORT1FROMMP(mp1)) {
         case SP_MONTH:
         switch(SHORT2FROMMP(mp1)) {
            case SPBN_CHANGE:
            if (WinSendDlgItemMsg(hwnd, SP_MONTH, SPBM_QUERYVALUE,
              MPFROMLONG(&selmo), MPFROM2SHORT(0, SPBQ_UPDATEIFVALID)))
                WinSendDlgItemMsg(hwnd, SP_DAY, SPBM_SETLIMITS,
                 MPFROMLONG(dim[selmo]), MPFROMLONG(1));
            return 0;
            }
         break;
         }
      break;

      case WM_COMMAND:
      switch(SHORT1FROMMP(mp1)) {
         case PB_DISPLAY:
         WinSendDlgItemMsg(hwnd, SP_DAY, SPBM_QUERYVALUE,
                MPFROMP(&day), MPFROM2SHORT(0, SPBQ_ALWAYSUPDATE));
         WinSendDlgItemMsg(hwnd, SP_MONTH, SPBM_QUERYVALUE,
                MPFROMP(month), MPFROM2SHORT(9, SPBQ_UPDATEIFVALID));
         WinSendDlgItemMsg(hwnd, SP_YEAR, SPBM_QUERYVALUE,
                MPFROMP(&year), MPFROM2SHORT(0, 0));
         sprintf(message, "%d %s %d", day, month, year);

         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, message,
              "Date Selected", 0, MB_OK | MB_INFORMATION);
         return 0;
         }

      case WM_CLOSE:
      WinPostMsg(hwnd, WM_QUIT, 0,0);
      return 0;
      }
 
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
   }

