#define INCL_DOS
#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <string.h>

#include "thread.h"

MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
VOID _System countfn(LONG param);

#define APPNORMAL    0
#define INITFAILURE -1
#define USERQUIT    -2

typedef struct {
   LONG   passes;
   LONG   progress;
   BOOL   update;
   BOOL   done;
   } SHARED;

typedef SHARED *PSHARED;


int main (void)
{
   HAB   hab;                    /* anchor-block handle  */
   HMQ   hmq;                    /* message queue handle */
   HWND  hwndFrame, hwndClient;  /* handles to windows   */
   QMSG  qmsg;                   /* message              */
   char  szClassName[] = "Multi-threading!!!!!!!";
   char  szWindowTitle[] = "Thread It, Baby!";
   ULONG flFrameOpts = FCF_STANDARD;
   ULONG appState = APPNORMAL;

   PSHARED wd;
 
   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab, 0);

   if (!WinRegisterClass(hab, szClassName, ClientWndProc,
                    CS_SIZEREDRAW, 4))
             appState = INITFAILURE;
   hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
                                &flFrameOpts, szClassName,
                                szWindowTitle, 0L, 0, 
                                THREADPROGRAMID,
                                &hwndClient);

   wd = (PSHARED)malloc(sizeof(SHARED));
   wd->done = FALSE;
   wd->update = FALSE;
   wd->progress = 0;
   wd->passes = 0;

   WinSetWindowPtr(hwndClient, 0, wd);

   if ((appState==INITFAILURE) || (hab==NULLHANDLE) ||
       (hmq==NULLHANDLE) || (hwndFrame==NULLHANDLE))
       WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to initialize application.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
   else 
   while (appState==APPNORMAL) {

      while (WinGetMsg(hab, &qmsg, 0, 0, 0))
      WinDispatchMsg(hab, &qmsg);

      if (WinSendMsg(hwndClient, WM_COMMAND, 
         MPFROM2SHORT(CMD_VERIFY, 0), 0) != MBID_CANCEL)
         appState = USERQUIT;

      if (qmsg.hwnd == NULLHANDLE) /*system shutdown */
         if (appState != USERQUIT) WinCancelShutdown(hmq, FALSE);

      }

   WinDestroyWindow(hwndFrame);
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   
   return 0;
   }

MRESULT EXPENTRY ClientWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{                         
   HPS     hps;
   RECTL   rcl;
   ULONG   cmd;
   TID     tid;
   PFN     pfn = &countfn;
   char    text[1000];
   PSHARED wd;

   /*event handler*/
   switch(msg) {

      case WM_PAINT:
      wd = WinQueryWindowPtr(hwnd, 0);
      hps = WinBeginPaint(hwnd, NULLHANDLE, NULLHANDLE);
      WinQueryWindowRect(hwnd, &rcl);
      WinFillRect(hps, &rcl, CLR_WHITE);
      if (wd->update) {
         sprintf(text, "Progress: %d", wd->progress);
         GpiSetBackMix(hps, BM_OVERPAINT);
         WinDrawText(hps, -1, text, &rcl, 0,0,
           DT_TEXTATTRS | DT_CENTER | DT_VCENTER); 
         wd->update = FALSE;
         }
      WinEndPaint(hps);
      return 0;


      case WM_COMMAND:

      switch(SHORT1FROMMP(mp1)) {

         case CMD_PROGRESS:
         wd = WinQueryWindowPtr(hwnd, 0);
         wd->progress = SHORT1FROMMP(mp2);
         wd->update = TRUE;
         WinInvalidateRect(hwnd, NULL, 0);
         return 0;

         case CMD_DONE:       
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Finished!", "Information!",
              0, MB_OK | MB_INFORMATION);
         return 0;

         case CMD_FILEDOIT:
         if (DosCreateThread(&tid, pfn, hwnd, 0, 8192)!=0)
         WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
              "Unable to create thread.", "ERROR!",
              0, MB_CANCEL | MB_ERROR);
         return 0;

         case CMD_VERIFY:
         cmd = MBID_NO;                                
         /* if (data_modified) */ {
            cmd = WinMessageBox(HWND_DESKTOP, hwnd,
                "Do you want to save your work before exiting?",
                "Query", 0, MB_YESNOCANCEL | MB_QUERY);
            /* if cmd==MB_YES save_data */
            } 
         return (MRESULT)cmd;
 
         /* case CMD_OTHERCOMMANDS: */

         } /* end WM_COMMAND messages */

      } /*end event handlers */
   return WinDefWindowProc(hwnd, msg, mp1, mp2);
   }

VOID _System countfn(HWND caller)
{
   LONG counter = 0;
   HAB  hab = WinInitialize(hab);                                
 
   while(counter < 5000) {
      counter = counter + 1;
      if (counter % 100 == 0) {
         WinPostMsg(caller, WM_COMMAND,
           MPFROMSHORT(CMD_PROGRESS),
           MPFROMSHORT(counter));
         }
      }
   WinPostMsg(caller, WM_COMMAND, MPFROMSHORT(CMD_DONE), 0);
   WinTerminate(hab);
   }

